'Nome       : LstPesos.sql
'Tipo       : SQL
'Data       : 2017/04/21
'Versao     : 1.0
'Descricao  : Listagem de pesos por fatura

'==============================================================================
'#VER - Historia de modificacoes
'==============================================================================
'- Versao : 1.0   2003/??/?? --------------------------------------------------
'Versao base


'==============================================================================
#DEF - Definicao global do documento
'==============================================================================
Caracteres invalidos             [CarInv]=#
Subtotalizadores                 [SbtNiv]= 
##


'==============================================================================
#ESP - Campos especificos
'==============================================================================
##


'==============================================================================
#SQL - Comandos SQL
'==============================================================================
Base de dados           [BD]=EmpFic$("EMP","Cemp,Emp_Dat.mdb")
'Base de dados           [BD]=EmpFic$("EMP","Enc,Enc.mdb")

Documentos a listar [Cmd]=ArtCli=+
+SELECT EncMst.Dtl, EncMov.[Tdoc$], EncMov.[Ndoc$], EncMst.[CtEnt$], {TB_CTAMST}.[Nome$], EncMov.[Art$], {TB_STCMST}.[CodBar$], {TB_STCMST}.[Nome1$], EncMov.Qu, EncMov.Prc FROM EncMov +
+INNER JOIN EncMst ON EncMov.[Tdoc$]=EncMst.[Tdoc$] AND EncMov.[Ndoc$]=EncMst.[Ndoc$] +
+INNER JOIN {TB_STCMST} ON EncMov.[Art$]={TB_STCMST}.[Art$] +
+INNER JOIN {TB_CTAMST} ON EncMst.[CtEnt$]={TB_CTAMST}.[Ct$] +
+WHERE EncMov.[Tdoc$] BETWEEN '{Opc_Tdoc.Ini}' AND '{Opc_Tdoc.Fim}' +
+AND EncMov.[Ndoc$] BETWEEN '{Opc_Ndoc.Ini}' AND '{Opc_Ndoc.Fim}' +
+AND EncMst.[CtEnt$] BETWEEN '{Opc_Ct.Ini}' AND '{Opc_Ct.Fim}' +
+AND EncMst.Dtl BETWEEN {Opc_Dtl.Ini} AND {Opc_Dtl.Fim} +
+AND EncMov.[Art$] <> '#TXL' +
+AND EncMov.RecVal <> 255 +
+ORDER BY EncMov.[Art$], EncMst.[CtEnt$]
##

'==============================================================================
#DOC - Configuracao do documento
'==============================================================================
Tipo                       [DocTip]=SQL
Nome                       [DocNom]=ArtCli,Listagem Artigos/Contas

'formato
Saida/Impressora           [DocPrt]=NULA
Linhas por pagina          [DocLpg]=50
Colunas por linha          [DocCol]=80
Formato do papel           [DocPap]=72L
Ajustar pagina             [DocApg]=0

'funcoes de listagem
Base para documento         [FxDOC]=ArtCliXls
Listar cabecalho            [FxCAB]=ArtCliXls_Cab
Listar linhas               [FxLIN]=ArtCliXls_Lin, 0
Listar fim                  [FxFIM]=ArtCliXls_Fim

Matriz auxiliar            [DocMat]=ArtCli.xls

'controlo de listagem SQL
Gerador de dados a listar  [SQLDat]=ArtCli
'Subtotalizadores           [SQLSbt]=
##


'==============================================================================
#VAR - Variaveis
'==============================================================================
Tipo     = MemTxt$(1)
Pag      = Doc_CntPag
Tit080   = TxTit$("TT=10CPI, LD, PT=40C",MemTxt$(1))
Tit132   = TxTit$("TT=16CPI, LD, PT=66C",MemTxt$(1))
DataExt  = FrmVal$(Sig_DtHoje,45,0)


'Campos
ctCod    = SqlCmp$("CtEnt$")
ctNom    = SqlCmp$("CtEnt$")

DocIde   = SqlCmp$("Tdoc$")+" "+FrmNdo$("46",SqlCmp$("Tdoc$"),SqlCmp$("Ndoc$"))
DocDt    = FrmDt$("",SqlCmp("Dtl"))
DocVnd   = FrmNum$( 3.0,SqlCmp("Vend"))
Vnd      = FrmNum$( 3.0,SqlCmp("Vend"))

vDocV1   = FrmNum$( 10.2,SqlCmp("ValTot"))
vDocV2   = FrmNum$( 10.2, val(TxIde$(SqlCmp$("EncMst.Opc$"),"TotMoeAlt")))

tDocN    = FrmNum$(  5.0,TotCnt("vDocV1",0))
tDocV1   = FrmNum$( 10.2,total(vDocV1,0))
tDocV2   = FrmNum$( 10.2,total(vDocV2,0))

sDocN    = FrmNum$(  5.0,TotCnt("vDocV1",1))
sDocV1   = FrmNum$( 10.2,total(vDocV1,1))
sDocV2   = FrmNum$( 10.2,total(vDocV2,1))
##


'==============================================================================
#PGM - Programa/Funcoes
'==============================================================================
'---------------------------------------------------------->'Comentario (61)
'------------------------------------------------->'Comentario (52)
'------------------------------------->'Comentario (40)

SUB FxIni 'funcao de inicializacao
Xg$ = ""
Fl = 0
XlsLin = 6
end sub


SUB FxFim 'funcao de finalizacao
end sub


SUB Lst_AJT 'ajuste
end sub



'=============================================================================
' XLS - Funcoes comuns
'=============================================================================
Sub Xls_DocIni 'inicializar documento
dfi$ = FicEmp$("EMP","Ext","dExcel",cmo$)          'directorio de documentos EXCEL
nfi$ = "RND:ArtCli.xls"                            'nome do ficheiro
cmo$ = SigCmoCur$("MIX")                           'modulo corrente
ficDoc$ = FicTmp$(dfi$, nfi$)                      'ficheiro para documento
res = DirCri("D", dfi$)                            'criar directorio para documento

xlsMatNom$ = DocOpc$("DocMat")                     'nome do ficheiro matriz
xlsMat$    = DocOpc$("DocMat+SBT")                 'endereco do ficheiro matriz

res = FicCop(xlsMat$, ficDoc$)                     'criar ficheiro (copia de matriz)
res = XlsPrp(0)                                    'preparar EXCEL
res = XlsDocLer(ficDoc$)                           'ler ficheiro

'res = XlsDocCri("")                                'criar documento
end sub


Sub Xls_DocFim 'terminar documento
'res = XlsLinEli(xlsLin, 1)                         'eliminar linha - ultima
'res = XlsLinEli(xlsLba, 1)                         'eliminar linha - primeira

res = XlsDocDir$("A", dfi$)                        'activar directorio
res = XlsDocGrv(ficDoc$)                           'gravar ficheiro

'res = XlsPrt(1)                                    'listar worksheet
'res = XlsVer(0)                                    'mostrar EXCEL - normal
res = XlsVer(1)                                    'mostrar EXCEL - maximizado
res = XlsLib(0)                                    'libertar EXCEL
end sub


Sub Xls_DocCab 'cabecalho do documento
empNum$ = Emp_Inf_Cod$+" - "+Emp_Inf_Nome$                             'numero da empresa
empNom$ = Emp_Inf_Nome$                            'nome da empresa
lstTit$ = MemTxt$(1)                               'titulo da listagem
lstTip$ = MemTxt$(2)                               'tipo da listagem
lstDt$  = "Data: "+FrmDt$("EXT", Sig_DtHoje)                'data para listagem

res = XlsIdeLst("Emp_Num", empNum$)                'numero da empresa
'res = XlsIdeLst("Emp_Nome", empNom$)               'nome da empresa
'res = XlsIdeLst("Lst_Tit", lstTit$)                'titulo da listagem
'res = XlsIdeLst("Lst_Tipo", lstTip$)               'tipo da listagem
res = XlsIdeLst("Lst_Data", lstDt$)                'data
end sub


Sub Xls_LinInc 'incrementar linha
xlsLsa = xlsLin                                    'linha de saida
res = XlsLinIns(xlsLin, 1)                         'juntar linha

'seguinte
xlsLin = xlsLin + 1                                'contar linha
end sub


Sub Xls_LinIni 'iniciar linhas
res = XlsIdePsq("PO_BAS")                          'pesquisar posicao base
linBav = XlsIdePsqRes("L")                         'linha da posicao base

xlsLba = linBav                                    'linha base
xlsLin = linBav + 1                                'contador de linhas usadas
end sub


Sub Xls_LinFim 'fim de linhas
res = XlsLinEli(xlsLin, 1)                         'eliminar linha - ultima
res = XlsLinEli(xlsLba, 1)                         'eliminar linha - primeira

res = XlsIdePsq("PO_FIM")                          'pesquisar posicao final
linFim = XlsIdePsqRes("L")                         'linha da posicao final
end sub


'=============================================================================
' Listagem Mapa de Vendas para EXCEL
'=============================================================================
Sub ArtCliXls_DocIni 'inicializar documento
call Xls_DocIni                                    'inicializar documento
'Msgbox "","","DocIni"
end sub


Sub ArtCliXls_Cab 'preparar para listar
res = XlsWks("Valores")                            'activar worksheet
call Xls_DocCab                                    'cabecalho do documento
XlsLin = 8
'Msgbox "","","Cab"
end sub


Sub ArtCliXls_Lin 'Memorizar Local / Guias
Ano$      = FrmDt$("A4",SqlCmp("EncMst.Dtl"))
Mes$      = FrmDt$("MES",SqlCmp("EncMst.Dtl"))
DocDt$    = FrmDt$("",SqlCmp("EncMst.Dtl"))
DocDes$   = SqlCmp$("EncMov.Tdoc$")+FrmNdo$("46",SqlCmp$("EncMov.Tdoc$"),SqlCmp$("EncMov.Ndoc$"))
CtI$      = SqlCmp$("EncMst.CtEnt$")
CliNom$   = SqlCmp$("CtaMst.Nome$")
Artm$     = SqlCmp$("StcMst.Art$")
ArtCb$    = SqlCmp$("StcMst.CodBar$")
ArtNome$  = SqlCmp$("StcMst.Nome1$")
Qu$       = FrmVal$(SqlCmp("EncMov.Qu"),21,6.2)
Vl        = SqlCmp("EncMov.Qu")*SqlCmp("EncMov.Prc")
Vl$       = FrmVal$(Vl,21,10.2)

res = XlsLst(XlsLin,2 , Ano$)
res = XlsLst(XlsLin,3 , Mes$)
res = XlsLst(XlsLin,4 , DocDt$)
res = XlsLst(XlsLin,5 , DocDes$)
res = XlsLst(XlsLin,6 , CtI$)
res = XlsLst(XlsLin,7 , CliNom$)
res = XlsLst(XlsLin,8 , Artm$)
res = XlsLst(XlsLin,9 , ArtCb$)
res = XlsLst(XlsLin,10 , ArtNome$)
res = XlsLst(XlsLin,11, Qu$)
res = XlsLst(XlsLin,12 , Vl$)

XlsLin = XlsLin + 1
res = XlsLinIns(xlsLin, 1)                         'juntar linha
End Sub

Sub ArtCliXls_Fim 'terminar documento
call Xls_DocFim                                    'terminar/mostrar documento
end sub
##
