'Nome       : DeBorla.sql
'Tipo       : LST
'Data       : 2007/03/02
'Versao     : 1.0
'Descricao  : Vendas para as Lojas DeBorla

'==============================================================================
'#VER - Historia de modificacoes
'==============================================================================
'- Versao : 1.0  2007/??/?? ---------------------------------------------------
'Versao Base


'==============================================================================
#DEF - Definicao global do documento
'==============================================================================
Caracteres invalidos             [CarInv]=#
##


'==============================================================================
#ESP - Campos especificos
'==============================================================================
Zoom para preview             [PrvZoom]=1.5
Opcoes para impressora WIN   [PrWinOpc]=[ORI=P]
##


'==============================================================================
#SQL - Comandos SQL
'==============================================================================
Base de dados           [BD]=EmpFic$("EMP","Cemp,Emp_Dat.mdb")

Dados a listar [Cmd]=ArtVnd=+
+ SELECT  DISTINCT [Art$] FROM StcMov{ano} + 
+ INNER JOIN CtaMst2010 on CtaMst2010.[Ct$]=StcMov{ano}.[Ct$] +
+ WHERE CtaMst2010.[Entid$]='11142' +
+ AND StcMov{ano}.Dtl between {Opc_Dtl.Ini} AND {Opc_Dtl.Fim} +
+ AND Cmv IN(9,-9,16,-16) +
+ AND StcMov{ano}.RecVal<>255 +
+ ORDER BY [Art$]

Dados a listar [Cmd]=LerIni=+
+ SELECT  Top 1 StcMov{ano}.Dtl as DtIni FROM StcMov{ano} + 
+ INNER JOIN CtaMst2010 on CtaMst2010.[Ct$]=StcMov{ano}.[Ct$] +
+ WHERE CtaMst2010.[Entid$]='11142' +
+ AND StcMov{ano}.Dtl between {Opc_Dtl.Ini} AND {Opc_Dtl.Fim} +
+ AND Cmv IN(9,-9,16,-16) +
+ AND StcMov{ano}.RecVal<>255 +
+ ORDER BY StcMov{ano}.Dtl

Dados a listar [Cmd]=LerFim=+
+ SELECT  Top 1 StcMov{ano}.Dtl as DtFim FROM StcMov{ano} + 
+ INNER JOIN CtaMst2010 on CtaMst2010.[Ct$]=StcMov{ano}.[Ct$] +
+ WHERE CtaMst2010.[Entid$]='11142' +
+ AND StcMov{ano}.Dtl between {Opc_Dtl.Ini} AND {Opc_Dtl.Fim} +
+ AND Cmv IN(9,-9,16,-16) +
+ AND StcMov{ano}.RecVal<>255 +
+ ORDER BY StcMov{ano}.Dtl Desc

Nome do artigo [Cmd]=ArtNom=+
   +SELECT Nome1$ as [NOME$] +
   +FROM {TB_StcMst} +
   +WHERE Art$ = '{ART.COD}'

##


'==============================================================================
#DOC - Configuracao do documento
'==============================================================================
Tipo                       [DocTip]=SQL
Nome                       [DocNom]=Doc2,Titulo da Listagem
Vias                       [DocVia]=Original
Personalizacao             [DocPer]=

'formato
Saida/Impressora           [DocPrt]=NULA
Linhas por pagina          [DocLpg]=500
Colunas por linha          [DocCol]=78
Formato do papel           [DocPap]=72L
Ajustar pagina             [DocApg]=0

'funcoes de listagem
Base para documento         [FxDOC]=XlsArt
Listar cabecalho            [FxCAB]=XlsArt_Cab
Listar linhas               [FxLIN]=XlsArt_Lin
Listar fim                  [FxFIM]=XlsArt_Fim

'controlo de listagem SQL
Gerador de dados a listar  [SQLDat]=ArtVnd
Subtotalizadores           [SQLSbt]=
Matriz auxiliar            [DocMat]=DeBorla.xls
##


'==============================================================================
#VAR - Variaveis
'==============================================================================
Tipo     = MemTxt$(1)
Pag      = Doc_CntPag
DataExt  = FrmVal$(Sig_DtHoje,45,0)

'Subtotais

##


'==============================================================================
#PGM - Programa/Funcoes
'==============================================================================
SUB FxIni 'funcao de inicializacao
'modo WIN
PrWIN AJT_F, 56.7,  56.7                           'ajuste para milimetros
PrWIN AJT_D,-280.0,-280.0                          'deslocamento de ajuste
'PrWIN IMG_F, 1, VarTx$("[SIG_DIR.DIV],OliLogo.bmp","R")     'imagem (logotipo)
PrWIN ET,  2                                       'espessura de traco

dimLinNor=4.4                                      'altura de uma linha normal
dimLinCab=6.6                                      'altura de uma linha de cabecalho

cnt=0                                              'limpar contador

x = VBS_IniLoja(a)                          'prepara array
end sub


SUB FxFim 'funcao de finalizacao
PrWIN FON, "REG"                                   'limpar registo de fontes
end sub


SUB Lst_AJT 'ajuste
end sub


'=============================================================================
' XLS - Funcoes comuns
'=============================================================================
Sub Xls_DocIni 'inicializar documento
dfi$ = FicEmp$("EMP","Ext","dExcel",cmo$)          'directorio de documentos EXCEL
nfi$ = "RND:DeBorla.xls"                            'nome do ficheiro
cmo$ = SigCmoCur$("MIX")                           'modulo corrente
ficDoc$ = FicTmp$(dfi$, nfi$)                      'ficheiro para documento
res = DirCri("D", dfi$)                            'criar directorio para documento

xlsMatNom$ = DocOpc$("DocMat")                     'nome do ficheiro matriz
xlsMat$    = DocOpc$("DocMat+SBT")                 'endereco do ficheiro matriz

res = FicCop(xlsMat$, ficDoc$)                     'criar ficheiro (copia de matriz)
res = XlsPrp(0)                                    'preparar EXCEL
res = XlsDocLer(ficDoc$)                           'ler ficheiro

'res = XlsDocCri("")                                'criar documento

'msgbox "","","Xls_DocIni"
end sub


Sub Xls_DocFim 'terminar documento
res = XlsDocDir$("A", dfi$)                        'activar directorio
res = XlsDocGrv(ficDoc$)                           'gravar ficheiro

'res = XlsPrt(1)                                    'listar worksheet
'res = XlsVer(0)                                    'mostrar EXCEL - normal
res = XlsVer(1)                                    'mostrar EXCEL - maximizado
res = XlsLib(0)                                    'libertar EXCEL
end sub


'seguinte
xlsLin = xlsLin + 1                                'contar linha
end sub

'=============================================================================
' Conferencia de Artigos (EXCEL)
'=============================================================================
Sub XlsArt_DocIni 'inicializar documento
'msgbox "","","XlsArt_DocIni"
call Xls_DocIni                                    'inicializar documento
call XlsArt_Prep                                'preparar
XlsLin = 10
fl=0
end sub


Sub XlsArt_Cab 'terminar documento
'msgbox "","","XlsArt_Cab"
end sub


Sub XlsArt_Fim 'terminar documento
call Xls_DocFim                                    'terminar/mostrar documento
end sub


Sub XlsArt_Prep 'preparar para listar
res = XlsWks("Valores")                            'activar worksheet
end sub


Sub XlsArt_IncLin 'incrementar linha	
xlsLin = xlsLin + 1                                'contar linha
res = XlsLinIns(xlsLin, 1)                         'juntar linha
end sub


Sub XlsArt_Lin 'linha de valores
'valores a listar

if fl = 0   then
   call IniDatas
   call IniCabecalho
   fl = 1
   X$ = FrmVal$(DtaIni,44,0)+" a "+FrmVal$(DtaFim,44,0)
   res = XlsLst(4, 3, x$)                    'Data
end if

art$ = SqlCmp$("Art$")                              'artigo
'res1  = SqlOpcAct("Art.Cod",art$)                    'registar artigo
'res  = SqlCalc("ARTNOM")                            'preparar nome do artigo

res = StcArtLer(art$)                           'preparar dados do artigo

artCov$  = StcCodFrm$(art$)                      'codigo formatado
artNom$  = STC_MST_Nome1$                           'nome
cba$     =STC_MST_CodBar$
VPeso    =STC_MST_Peso
xPv1     =STC_MST_Pv1
xPv2     =STC_MST_Pv2
xPv3     =STC_MST_Pv3


'cba$     =sqlOpcCon$("CodBar$")
'nom$     =sqlOpcCon$("Nome1$")
'VPeso    =sqlOpcCon("VPeso")
'pv1      =sqlOpcCon("Pv1")
'pv2      =sqlOpcCon("Pv2")
'pv3      =sqlOpcCon("Pv3")

'msgbox "",Art$,Xlslin

call XlsArt_IncLin                              'incrementar linha	

'listar
res = XlsLst(XlsLin, 2, cba$)                   'Codigo de Barras
res = XlsLst(XlsLin, 3, art$)                   'codigo artigo
res = XlsLst(XlsLin, 4, Artnom$)                   'descricao
res = XlsLst(XlsLin, 5, VPeso)                  'Peso
res = XlsLst(XlsLin, 6, xPv1)                    'preco 1
res = XlsLst(XlsLin, 7, xPv2)                    'preco 2
res = XlsLst(XlsLin, 8, xPv3)                    'preco 2

ColB   = 9
TotVlr = 0
TotQua = 0

for i=1 to lin
CtLoja$=VBS_LerCt(i)


Sql$=" SELECT [Ct$], Sum"+Pa$+"Vt"+Pf$+" as VlSom, Sum"+Pa$+"Qu"+Pf$+" as QuSom FROM StcMov"+ano$
Sql$=Sql$+" where [Ct$]='"+CtLoja$+"' and [Art$]='"+Art$+"' and Dtl between "+DtaIni+" AND "+DtaFim
Sql$=Sql$+" and cmv in"+Pa$+"9,-16"+Pf$+" and RecVal<>255 group by [Ct$]"

res = SqlQryGer(Idq$,sql$)   'gerar recordset

'msgbox "",res,sql$

if Res = 1   then
   VlSom = SqlQryCmp(idq$, "VlSom")
   QuSom = SqlQryCmp(idq$, "QuSom")
else
   VlSom = 0
   QuSom = 0
end if

Sql$=" SELECT [Ct$], Sum"+Pa$+"Vt"+Pf$+" as VlSub, Sum"+Pa$+"Qu"+Pf$+" as QuSub FROM StcMov"+ano$
Sql$=Sql$+" where [Ct$]='"+CtLoja$+"' and [Art$]='"+Art$+"' and Dtl between "+DtaIni+" AND "+DtaFim
Sql$=Sql$+" and cmv in"+Pa$+"-9,16"+Pf$+" and RecVal<>255 group by [Ct$]"

res = SqlQryGer(Idq$,sql$)   'gerar recordset
if Res = 1   Then
   VlSub = SqlQryCmp(idq$, "VlSub")
   QuSub = SqlQryCmp(idq$, "QuSub")
else
   VlSub = 0
   QuSub = 0
end if

Vlr = VlSom - VlSub
Qua = QuSom - QuSub
TotVlr = TotVlr + Vlr
TotQua = TotQua + Qua

res = XlsLst(XlsLin, ColB, Vlr)                   'Codigo de Barras
res = XlsLst(XlsLin, ColB+1, Qua)                   'Codigo de Barras
colb= Colb +2

next

res = XlsLst(XlsLin, ColB-2, TotVlr)                   'Codigo de Barras
res = XlsLst(XlsLin, ColB-1, TotQua)                   'Codigo de Barras

end sub


Sub XlsArt_LinSep 'linha de separacao
call XlsArt_IncLin                              'incrementar linha
end sub



Sub XlsCnfArt_Fim 'terminar
'mostrar
res = XlsWksAct("A", 1)                            'activar worksheet
'call XlsCnfArt_DocFim                              'terminar documento
end sub

Sub IniDatas
res = SqlCalc("LERINI")                       'vendas - valores a somar
DtaIni = SqlOpcCon("DTINI")

res = SqlCalc("LERFIM")                       'vendas - valores a somar
DtaFim = SqlOpcCon("DTFIM")

'msgbox "",DtaIni,DtaFim
End sub

Sub IniCabecalho
x=VBS_IniLoja                               'prepara array
Idq$ = ""
res =  SqlDbPrp(Idq$)
ano$=FrmDt$("A4",Sig_DtHoje)
Lin=1
ColBase = 9
Pa$="("
Pf$=")"


sql$="SELECT CtaMst2010.[Ct$] as CntLoja, CtaAng2010.[Nome2$] as NomLoja FROM StcMov"+ano$
sql$=Sql$+" inner join CtaMst2010 on StcMov"+ano$+".[Ct$]=CtaMst2010.[Ct$]"
sql$=Sql$+" inner join CtaAng2010 on StcMov"+ano$+".[Ct$]=CtaAng2010.[Ct$]"
Sql$=Sql$+" where Entid$='11142' AND Dtl between "+DtaIni+" AND "+DtaFim
Sql$=Sql$+" and Cmv IN"+Pa$+"9,16"+Pf$+" and StcMov"+ano$+".RecVal<>255"
Sql$=Sql$+" group by CtaMst2010.[Ct$], CtaAng2010.[Nome2$]"

res = SqlQryGer(Idq$,sql$)   'gerar recordset
'msgbox "",Res,Sql$

while res=1
CntLoja$=SqlQryCmp$(idq$, "CntLoja")
NomLoja$=SqlQryCmp$(idq$, "NomLoja")
x=VBS_MemLoja(Lin,CntLoja$,NomLoja$)  'memorizar linha

res = XlsFormCop(8,Colbase,8,Colbase+2)
res = XlsFormCop(8,Colbase+1,8,Colbase+3)
res = XlsFormCop(9,Colbase,9,Colbase+2)
res = XlsFormCop(9,Colbase+1,9,Colbase+3)
res = XlsFormCop(10,Colbase,10,Colbase+2)
res = XlsFormCop(10,Colbase+1,10,Colbase+3)
res = XlsFormCop(11,Colbase,11,Colbase+2)
res = XlsFormCop(11,Colbase+1,11,Colbase+3)
res = XlsLst(8, ColBase, NomLoja$)                   'Codigo de Barras

Colbase = Colbase + 2
lin = lin +1
Res=SqlQryRgs(idq$)
wend


end sub
##

'-----------------------------------------------------------------------------
#VBS
'-----------------------------------------------------------------------------
dim Loja()                           'linhas memirizadas

Function IniLoja(arg) 'prepara array
'arg        - argumento (nao usado)

'msgbox "IniLin 1"

redim Loja(100, 2)                   'reservar espaco para linhas

'msgbox "IniLin 2"
end function


Function MemLoja(lin, Ct, Nome) 'memorizar linha
'lin        - linha
'Ct         - Conta
'Nome       - Nome da conta

Loja(lin,1)=Ct                      'tipo de doc.
Loja(lin,2)=Nome                    'num. de doc.

'msgbox "Lin " & Ct & " >" & Nome & "<" 
'msgbox "MemLin " & lin & " >" & tdoc & "< >" & vl & "<"
'msgbox vl 
end function


Function LerCt(lin) 'ler tipo. doc.
'lin        - linha
LerCt=Loja(lin,1)                 'tipo de doc.

end function

Function LerNome(lin) 'ler tipo. doc.
'lin        - linha
LerNome=Loja(lin,2)                 'tipo de doc.

end function

##

