'Nome       : NaoVende.sql
'Tipo       : LST
'Data       : 2007/03/02
'Versao     : 1.0
'Descricao  : Artigos nao vendidos (para uma conta)

'-------------------------------------------------------------------------------
#DEF - Definicao global do documento
'-------------------------------------------------------------------------------
Caracteres invalidos             [CarInv]=#
##


'-------------------------------------------------------------------------------
#ESP - Campos especificos
'-------------------------------------------------------------------------------
Zoom para preview             [PrvZoom]=1.5
Opcoes para impressora WIN   [PrWinOpc]=[ORI=P]
##


'-------------------------------------------------------------------------------
#SQL - Comandos SQL
'-------------------------------------------------------------------------------
Base de dados           [BD]=EmpFic$("EMP","Cemp,Emp_Dat.mdb")

Dados a listar [Cmd]=ArtVndNao=+
+SELECT Art$ as ArtCod, Nome1$ as ArtNom +
+FROM StcMst AS MST +
+WHERE not exists +
+(select Distinct Art$ from StcMov{Ano} +
+Where MST.Art$ = MOV.Art$ AND MOV.ct$ = '{Opc_Ct.Ini}' )
'+Where MST.Art$ = MOV.Art$ AND MOV.ct$ = '{Opc_Ct.Ini}' AND StcMov{ANO}.Dtl BETWEEN {Opc_Dtl.Ini} AND {Opc_Dtl.Fim} AND  StcMov{ANO}.RecVal<>255)

Dados a listar [Cmd]=ArtVndSim=+
+SELECT Art$ as ArtCod, Nome1$ as ArtNom +
+FROM StcMst AS MST +
+WHERE exists +
+(select Distinct Art$ from StcMov{Ano} MOV +
+Where MST.Art$ = MOV.Art$ AND MOV.ct$ = '{Opc_Ct.Ini}' )
'+WHERE StcMov{ANO}.Dtl BETWEEN {Opc_Dtl.Ini} AND {Opc_Dtl.Fim} AND  StcMov{ANO}.RecVal<>255

##


'-------------------------------------------------------------------------------
#DOC - Configuracao do documento
'-------------------------------------------------------------------------------
Tipo                       [DocTip]=SQL
Nome                       [DocNom]=VndNao,Artigos que no Compra

'formato
Saida/Impressora           [DocPrt]=
Linhas por pagina          [DocLpg]=50
Colunas por linha          [DocCol]=80
Formato do papel           [DocPap]=72L
Ajustar pagina             [DocApg]=0
Especifico do documento    [DocEsp]=TipoLst=TXT

'funcoes de listagem
Listar cabecalho            [FxCAB]=Doc1_Cab
Listar linhas               [FxLIN]=Doc1_Lin
Listar fim                  [FxFIM]=Doc1_Fim

'controlo de listagem SQL
Gerador de dados a listar  [SQLDat]=ArtVndNao
Subtotalizadores           [SQLSbt]=
##


'-------------------------------------------------------------------------------
#DOC - Configuracao do documento
'-------------------------------------------------------------------------------
Tipo                       [DocTip]=SQL
Nome                       [DocNom]=VndSim,Artigos que Compra

'formato
Saida/Impressora           [DocPrt]=
Linhas por pagina          [DocLpg]=50
Colunas por linha          [DocCol]=80
Formato do papel           [DocPap]=72L
Ajustar pagina             [DocApg]=0
Especifico do documento    [DocEsp]=TipoLst=TXT

'funcoes de listagem
Listar cabecalho            [FxCAB]=Doc1_Cab
Listar linhas               [FxLIN]=Doc1_Lin
Listar fim                  [FxFIM]=Doc1_Fim

'controlo de listagem SQL
Gerador de dados a listar  [SQLDat]=ArtVndSim
Subtotalizadores           [SQLSbt]=
##



'-------------------------------------------------------------------------------
#DOC - Configuracao do documento
'-------------------------------------------------------------------------------
Tipo                       [DocTip]=SQL
Nome                       [DocNom]=Doc2,Titulo da Listagem
Vias                       [DocVia]=Original
Personalizacao             [DocPer]=

'formato
Saida/Impressora           [DocPrt]=PAG_W
'Saida/Impressora           [DocPrt]=PAG_W,PRV
Linhas por pagina          [DocLpg]=50
Colunas por linha          [DocCol]=78
Formato do papel           [DocPap]=72L
Ajustar pagina             [DocApg]=0
Especifico do documento    [DocEsp]=TipoLst=GRF

'funcoes de listagem
Listar cabecalho            [FxCAB]=Doc2_Cab
Listar linhas               [FxLIN]=Doc2_Lin
Listar fim                  [FxFIM]=Doc2_Fim

'controlo de listagem SQL
Gerador de dados a listar  [SQLDat]=GerDli
Subtotalizadores           [SQLSbt]=
##


'-------------------------------------------------------------------------------
#VAR - Variaveis
'-------------------------------------------------------------------------------
Tipo     = MemTxt$(1)
Pag      = Doc_CntPag
DataExt  = FrmVal$(Sig_DtHoje,45,0)


TotNr    = FrmNum$(6.0,TotNr)
SbtId    = SbtIde$
SbtNr    = FrmNum$(6.0,SbtNr)

'Campos
C01 = StcCodFrm$(SqlCmp$("ArtCod"))
C02 = left$(SqlCmp$("ArtNom"), 30)

'Subtotais
##


'-------------------------------------------------------------------------------
#PGM - Programa/Funcoes
'-------------------------------------------------------------------------------
SUB FxIni 'funcao de inicializacao
'modo WIN
PrWIN AJT_F, 56.7,  56.7                           'ajuste para milimetros
PrWIN AJT_D,-280.0,-280.0                          'deslocamento de ajuste
'PrWIN IMG_F, 1, VarTx$("[SIG_DIR.DIV],OliLogo.bmp","R")     'imagem (logotipo)
PrWIN ET,  2                                       'espessura de traco

dimLinNor=4.4                                      'altura de uma linha normal
dimLinCab=6.6                                      'altura de uma linha de cabecalho

cnt=0                                              'limpar contador
end sub


SUB FxFim 'funcao de finalizacao
PrWIN FON, "REG"                                   'limpar registo de fontes
end sub


SUB Lst_AJT 'ajuste
end sub


'- Doc1 ------------------------------------------------------------------------
SUB Doc1_FimAjt 'fim de pagina intermedia
'TotNr=TotCnt("C01",0)                             'numero de registos
?================================================================================
'if UsaTot > 0 then
'?
'?================================================================================
'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
'end if

FxDiv LstPer,SP                                    'fim de pagina
'Print PrtCmd("[SP]");                             'fim de pagina
end sub


SUB Doc1_CabIni 'inicializar listagem
cntDoc=0
UsaTot=0
end sub


SUB Doc1_Cab 'cabecalho de listagem
FxDiv LstIde,10CPI,0
print TxTit$("TT=10CPI, LD, PT=40C, TL=10CPI",MemTxt$(1))
?Data : @DataExt                                                 Folha No : @Pag#
'123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.
?================================================================================
?Cdigo do Artig         Nome do Artigo
?================================================================================
'AAAAAAAAAAAAAAA AAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
'<-------------> <---------------------------->
end sub


SUB Doc1_Lin 'linha de valores
?@C01            @C02                                                           #
end sub


SUB Doc1_Fim 'fim de listagem
TotNr=TotCnt("C01",0)                              'numero de registos
'123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.
?================================================================================
if UsaTot > 0 then
?                                                                               #
?================================================================================
'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
end if

FxDiv LstPer,SP                                    'fim de pagina
'Print PrtCmd("[SP]");                             'fim de pagina
end sub


'- Doc2 ------------------------------------------------------------------------
Sub Cab132 'cabecalho para 132 colunas
PrWIN AJT_B, 10.0, 0.0                             'posicao base

cabX1=3                                            'limite X1
cabX2=190                                          'limite X2
cabY1=25                                           'limite Y1
cabY2=cabY1+CabLin*dimLinCab                       'limite Y2
cabYm=cabY2+55*dimLinNor                           'limite Y maximo

PrWIN COR_F, 15                                    'cor de fundo

PrWIN FON, 10, 1                                   'activar fonte
'PrWIN TX_N, cabX2-100,  5,VarTx$(EMP_INF_NOME$)    'nome da empresa
PrWIN TX_N, cabX2-100,  5,EmpCurIde$("IDE")        'nome da empresa
PrWIN FON, 18, 1                             	   'activar fonte
PrWin FON, "BOLD+"                                 'activar bold
PrWIN TX_CTR,  cabX1, 5, cabX2, cabY1,MemTxt$(1)   'titulo centrado
PrWin FON, "BOLD-"                                 'desactivar bold
PrWIN FON, 10, 1                             	   'activar fonte

py   =cabY1-dimLinNor-1                            'posicao Y
pxFol=CabX2-30                                     'posicao X para folha
pxPag=CabX2-10                                     'posicao X para pagina

PrWIN TX_N,   05, py,"Data :"                      'data
PrWIN TX_N,   16, py,@DataExt                      'listar data
PrWIN TX_N,pxFol, py,"Folha No :"                  'folha
PrWIN TX_N,pxPag, py,@Pag                          'numero da folha

PrWIN COR_E, 200, 200, 200                         'cor de enchimento RGB
PrWIN GR_ME, 0                                     'modo de enchimento

PrWIN GR_CE,  cabX1, cabY1, cabX2, cabY2, 2        'caixa do cabecalho

if UsaEnv=1 then
PrWIN GR_CX,  cabX1, cabY1, cabX2, cabYm, 2     'caixa envolvente
end if
End Sub


SUB Doc2_Cab 'cabecalho
CabLin = 1                                         'linhas de cabecalho
call Cab132                                        'listar cabecalho
PrWIN AJT_B,  8.0, 0.0                             'posicao base

PrWin FON, "BOLD+"                                 'activar bold
call Doc2_CabCol                                   'titulos das colunas
PrWin FON, "BOLD-"                                 'desactivar bold
end sub


SUB Doc2_LinPos 'posicao de linha
PrWIN AJT_B,  8, 31+Doc_CntLin*4.4                 'posicao base
'PrWIN TX_N,  -3,  0,Doc_CntLin                    'numero da linha - DEBUG
end sub


SUB Doc2_Lin 'linha
call Doc2_LinPos                                   'posicionar linha
call Doc2_LinCol                                   'listar colunas
end sub


SUB Doc2_Fim 'fim de listagem
TotNr=TotCnt("C01",0)                              'numero de registos
tmp=CntLin("INC",-2)                               'contar linha (sem nova pagina)
call Doc2_LinPos                                   'posicionar linha
if UsaTot > 0 then
call Doc2_FimCol                                'listar totais
end if

PrWIN FP                                           'fim de pagina
end sub


SUB Doc2_FimAjt 'fim de pagina intermedia
'TotNr=TotCnt("C01",0)                             'numero de registos
'tmp=CntLin("INC",-1)                              'contar linha (sem nova pagina)
'call Doc2_LinPos                                  'posicionar linha
'if UsaTot > 0 then
'   call Doc2_FimCol                               'listar totais
'end if

PrWIN FP                                           'fim de pagina
end sub


SUB Doc2_CabIni 'inicializar listagem
cntDoc=0                                           'limpar contador
UsaTot=0                                  'usar totais
UsaEnv=1                                  'usar envolvente
UsaSpc=1                                  'usar separador de colunas
end sub


SUB Doc2_CabCol
PrWIN TX_CTR,  5.0,cabY1, 38.6,cabY2,"Cdigo do Artigo"
PrWIN TX_CTR, 38.6,cabY1,101.6,cabY2,"Nome do Artigo"

if UsaSpc > 0 then
PrWIN GR_LI, 38.6,cabY1, 38.6,cabYm,2
PrWIN GR_LI,101.6,cabY1,101.6,cabYm,2
end if
end sub


SUB Doc2_LinCol
PrWIN TX_N,  6.0,0,@C01
PrWIN TX_N, 39.6,0,@C02
end sub

##

